﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Reflection;
using Newtonsoft.Json.Serialization;
using Newtonsoft.Json;
using System.Threading;
using System.IO;
using System.Resources;
using System.Globalization;

namespace VCMC
{
    public partial class MainForm : Form
    {
        // Hjsm Uifz`sf bmm j hpu, mjlf ju?
        // Хцяд имп цкхмс, фцс чцщумлхрс чзъшцх хз чцу; Ъшыч имп рлмс, иылъц щмшлюм имп шръфз
        string token;
        string nickname;
        bool exit;
        ResourceManager rm = new ResourceManager("VCMC.MainForm", Assembly.GetExecutingAssembly());
        string Message_WantToLogout;
        string Message_WantToExit;
        string Title_Contacts;
        public MainForm(string atoken, string anickname)
        {
            InitializeComponent();
            token = atoken;
            nickname = anickname;
            Title_Contacts = rm.GetString("lang_contacts");
            Message_WantToExit = rm.GetString("lang_wantexit");
            Message_WantToLogout = rm.GetString("lang_wantlogout");
        }

        private void getAdInForm()
        {
            string adurl = api.getAd();
            adurl = adurl.Replace("\\", "");
            var request = WebRequest.Create(adurl);
            using (var response = request.GetResponse())
            using (var stream = response.GetResponseStream())
            {
                pictureBoxAd.Image = Bitmap.FromStream(stream);
            }
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            string[] aboutus = api.getUser(nickname);
            if (aboutus[0] == "True")
            {
                this.Text = aboutus[1] + " (" + aboutus[3] + ") - Veselcraft Messenger";
            }
            else
            {
                MessageBox.Show(aboutus[2], "Oops!");
            }
            switch (Properties.Settings.Default.status_bar_visible)
            {
                case false:
                    statusStrip1.Visible = false;
                    statusBarToolStripMenuItem.Checked = false;
                    break;
            }
            switch (Properties.Settings.Default.pin_on_top)
            {
                case true:
                    pinOnTopToolStripMenuItem.Checked = true;
                    this.TopMost = true;
                    break;
            }
            getAdInForm();
            setContactList();
            timerMessages.Start();
        }

        private void logoutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show(Message_WantToLogout, "Veselcraft Messenger", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation) == DialogResult.Yes)
            {
                token = "";
                nickname = "";
                FormLogin fl = new FormLogin();
                fl.Show();
                this.Hide();
            }
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show(Message_WantToExit, "Veselcraft Messenger", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation) == DialogResult.Yes)
            {
                exit = true;
                Application.Exit();
            }
        }

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Show();
            this.Activate();
        }

        private void MainForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (exit == false)
            {
                e.Cancel = true;
                notifyIconVC.ShowBalloonTip(5000, "Veselcraft Messenger", "I'm hidden here! Click here to show again.", ToolTipIcon.Info);
                this.Hide();
            }
                
        }

        private void timerAd_Tick(object sender, EventArgs e)
        {
            getAdInForm();
        }

        private void statusBarToolStripMenuItem_Click(object sender, EventArgs e)
        {
            switch (statusBarToolStripMenuItem.Checked)
            {
                case true:
                    Properties.Settings.Default.status_bar_visible = false;
                    statusBarToolStripMenuItem.Checked = false;
                    statusStrip1.Visible = false;
                    break;
                case false:
                    Properties.Settings.Default.status_bar_visible = true;
                    statusBarToolStripMenuItem.Checked = true;
                    statusStrip1.Visible = true;
                    break;
            }
        }

        private void pinOnTopToolStripMenuItem_Click(object sender, EventArgs e)
        {
            switch (pinOnTopToolStripMenuItem.Checked)
            {
                case true:
                    Properties.Settings.Default.pin_on_top = false;
                    pinOnTopToolStripMenuItem.Checked = false;
                    this.TopMost = false;
                    break;
                case false:
                    Properties.Settings.Default.pin_on_top = true;
                    pinOnTopToolStripMenuItem.Checked = true;
                    this.TopMost = true;
                    break;
            }
        }
        
        public static List<contactListUserInfo> JsonParseCounties(string jsonText)
        {
            return JsonConvert.DeserializeObject<contactList>(jsonText).Counties;
        }

        private void treeViewFriends_DoubleClick(object sender, EventArgs e)
        {
            if (treeViewFriends.SelectedNode.Text != Title_Contacts)
            {
                FormMessages fm = new FormMessages(token, treeViewFriends.SelectedNode.Text);
                fm.Show();
            }
        }

        private void timerMessages_Tick(object sender, EventArgs e)
        {
            string[] update = api.getUpdatesMessages(token, null, 2);
            if (update[0] == "True")
            {
                if (update[2] == "1")
                {
                    notifyIconVC.ShowBalloonTip(10000, "New message from " + update[4] + "!", update[3], ToolTipIcon.Info);
                }
            }
            else
            {
                MessageBox.Show(update[1], "Oops");
                timerMessages.Stop();
            }
        }

        private void setStatus(string text)
        {
            toolStripStatusLabelStatus.Text = text;
        }

        private void sendInstantMessageToolStripMenuItem_Click(object sender, EventArgs e)
        {
            FormSendM fsm = new FormSendM(token);
            fsm.ShowDialog();
        }

        private void setContactList()
        {
            treeViewFriends.Nodes.Clear();
            TreeNode NodeList = new TreeNode(Title_Contacts);
            treeViewFriends.Nodes.Add(NodeList);
            String cl = api.getContactList(token);
            foreach (contactListUserInfo userinfo in JsonParseCounties(cl))
            {
                NodeList.Nodes.Add(userinfo.nickname);
            }
            NodeList.Expand();
        }

        private void addDeleteContactToolStripMenuItem_Click(object sender, EventArgs e)
        {
            FormADContacts fadc = new FormADContacts(token);
            if (fadc.ShowDialog() == DialogResult.OK)
            {
                setContactList();
            }
        }

        private void englishToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Properties.Settings.Default.language = "en";
            MessageBox.Show("Restart app for applying changes", "Veselcraft Messenger", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void russianToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Properties.Settings.Default.language = "ru";
            MessageBox.Show("Перезапустите приложение для применения изменений", "Veselcraft Messenger", MessageBoxButtons.OK, MessageBoxIcon.Information);

        }
    }

    public class contactList
    {
        public bool ok { get; set; }
        public string error { get; set; }
        [JsonProperty("contact")]
        public List<contactListUserInfo> Counties { get; set; }
    }

    public class contactListUserInfo
    {
        public string name { get; set; }
        public string nickname { get; set; }
    }
}
