﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HTTPClient = VCMC.HTTPClient;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System.IO;

namespace VCMC
{
    class api
    {

        public static string serverUrl = Properties.Settings.Default.server;
        public static string getServerUrl()
        {
            return serverUrl;
        }

        public static string[] getUser(string nickname)
        {
            String userJson = HTTPClient.GetRequest(serverUrl + "/getUser.php?username=" + nickname);
            user userjsoned = JsonConvert.DeserializeObject<user>(userJson);
            String[] userjsonStr = new String[4];
            userjsonStr[0] = userjsoned.ok.ToString();
            userjsonStr[1] = userjsoned.nickname;
            userjsonStr[2] = userjsoned.error;
            userjsonStr[3] = userjsoned.name;
            return userjsonStr;
        }

        public static string[] getUpdatesMessages(string token, string nickname, int type)
        {
            String messageJson = HTTPClient.GetRequest(serverUrl + "/getUpdatesMessages.php?token=" + token + "&nickname=" + nickname);
            message messagejsoned = JsonConvert.DeserializeObject<message>(messageJson);
            String[] messagejsonStr = new String[5];
            messagejsonStr[0] = messagejsoned.ok.ToString();
            messagejsonStr[1] = messagejsoned.error;
            messagejsonStr[2] = messagejsoned.messageIsExsit.ToString();
            messagejsonStr[3] = messagejsoned.text;
            messagejsonStr[4] = messagejsoned.nickname;
            return messagejsonStr;
        }

        public static string[] sendMessage(string token, string nickname, string text)
        {
            String messageJson = HTTPClient.GetRequest(serverUrl + "/sendMessage.php?token=" + token + "&nickname=" + nickname + "&text=" + text);
            sendMessage messagejsoned = JsonConvert.DeserializeObject<sendMessage>(messageJson);
            String[] messagejsonStr = new String[4];
            messagejsonStr[0] = messagejsoned.ok.ToString();
            messagejsonStr[1] = messagejsoned.error;
            return messagejsonStr;
        }

        public static string getAd()
        {
            String adJson = HTTPClient.GetRequest(serverUrl + "/getAd.php");
            ad adjsoned = JsonConvert.DeserializeObject<ad>(adJson);
            return adjsoned.url;
        }

        public static string getContactList(string token)
        {
            string content = HTTPClient.GetRequest(serverUrl + "/getContactList.php?token=" + token);
            return content;
        }

        public static string[] addDelContactList(string token, string nickname, string action)
        {
            String contactJson = HTTPClient.GetRequest(serverUrl + "/addDelContact.php?token=" + token + "&nickname=" + nickname + "&action=" + action);
            sendMessage contactjsoned = JsonConvert.DeserializeObject<sendMessage>(contactJson);
            String[] contactjsonStr = new String[4];
            contactjsonStr[0] = contactjsoned.ok.ToString();
            contactjsonStr[1] = contactjsoned.error;
            return contactjsonStr;
        }
    }

    public class user
    {
        public bool ok { get; set; }
        public string name { get; set; }
        public string nickname { get; set; }
        public string error { get; set; }
    }

    public class message
    {
        public bool ok { get; set; }
        public string error { get; set; }
        public int messageIsExsit { get; set; }
        public string text { get; set; }
        public string date { get; set; }
        public string nickname { get; set; }
    }

    public class sendMessage
    {
        public bool ok { get; set; }
        public string error { get; set; }
    }

    public class ad
    {
        public bool ok { get; set; }
        public string url { get; set; }
    }
}

